/*!
 * jquery-sticky-table-header
 * 1.1.1
 * Requires jQuery 1.12.0+
 * https://github.com/simonsmith/jquery.stickyTableHeader/
 * License: MIT
 */
(function webpackUniversalModuleDefinition(root, factory) {
    if (typeof exports === "object" && typeof module === "object") module.exports = factory(require("jquery")); else if (typeof define === "function" && define.amd) define([ "jquery" ], factory); else {
        var a = typeof exports === "object" ? factory(require("jquery")) : factory(root["jQuery"]);
        for (var i in a) (typeof exports === "object" ? exports : root)[i] = a[i];
    }
})(window, function(__WEBPACK_EXTERNAL_MODULE__1__) {
    return function(modules) {
        var installedModules = {};
        function __webpack_require__(moduleId) {
            if (installedModules[moduleId]) {
                return installedModules[moduleId].exports;
            }
            var module = installedModules[moduleId] = {
                i: moduleId,
                l: false,
                exports: {}
            };
            modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
            module.l = true;
            return module.exports;
        }
        __webpack_require__.m = modules;
        __webpack_require__.c = installedModules;
        __webpack_require__.d = function(exports, name, getter) {
            if (!__webpack_require__.o(exports, name)) {
                Object.defineProperty(exports, name, {
                    enumerable: true,
                    get: getter
                });
            }
        };
        __webpack_require__.r = function(exports) {
            if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
                Object.defineProperty(exports, Symbol.toStringTag, {
                    value: "Module"
                });
            }
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
        };
        __webpack_require__.t = function(value, mode) {
            if (mode & 1) value = __webpack_require__(value);
            if (mode & 8) return value;
            if (mode & 4 && typeof value === "object" && value && value.__esModule) return value;
            var ns = Object.create(null);
            __webpack_require__.r(ns);
            Object.defineProperty(ns, "default", {
                enumerable: true,
                value: value
            });
            if (mode & 2 && typeof value != "string") for (var key in value) __webpack_require__.d(ns, key, function(key) {
                return value[key];
            }.bind(null, key));
            return ns;
        };
        __webpack_require__.n = function(module) {
            var getter = module && module.__esModule ? function getDefault() {
                return module["default"];
            } : function getModuleExports() {
                return module;
            };
            __webpack_require__.d(getter, "a", getter);
            return getter;
        };
        __webpack_require__.o = function(object, property) {
            return Object.prototype.hasOwnProperty.call(object, property);
        };
        __webpack_require__.p = "";
        return __webpack_require__(__webpack_require__.s = 0);
    }([ function(module, exports, __webpack_require__) {
        function _classCallCheck(instance, Constructor) {
            if (!(instance instanceof Constructor)) {
                throw new TypeError("Cannot call a class as a function");
            }
        }
        function _defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }
        function _createClass(Constructor, protoProps, staticProps) {
            if (protoProps) _defineProperties(Constructor.prototype, protoProps);
            if (staticProps) _defineProperties(Constructor, staticProps);
            return Constructor;
        }
        var $ = __webpack_require__(1);
        var throttle = __webpack_require__(2);
        var PLUGIN_NAME = "stickyTableHeader";
        var instanceCount = 1;
        var StickyTableHeader = function() {
            _createClass(StickyTableHeader, null, [ {
                key: "getTableSizes",
                value: function getTableSizes($table) {
                    var offset = $table.offset();
                    var height = $table.outerHeight();
                    return {
                        bottomPos: offset.top + height,
                        height: height,
                        topPos: offset.top,
                        width: $table.outerWidth()
                    };
                }
            }, {
                key: "constructHeader",
                value: function constructHeader($thead, origTableClassName, _ref, _ref2) {
                    var width = _ref.width;
                    var header = _ref2.css.header, top = _ref2.offset.top, zIndex = _ref2.zIndex;
                    var $clone = $thead.clone(true);
                    return $("<table/>", {
                        "aria-hidden": true,
                        class: header
                    }).addClass(origTableClassName).css({
                        top: top,
                        position: "absolute",
                        boxSizing: "border-box",
                        zIndex: zIndex,
                        width: width
                    }).append($clone);
                }
            }, {
                key: "logError",
                value: function logError(message) {
                    console.error("".concat(PLUGIN_NAME, ": ").concat(message));
                }
            }, {
                key: "getOriginalCellWidths",
                value: function getOriginalCellWidths($thead) {
                    return $thead.find("tr").map(function() {
                        return $(this).find("td, th").map(function() {
                            return this.getBoundingClientRect().width;
                        });
                    });
                }
            }, {
                key: "setCloneCellWidths",
                value: function setCloneCellWidths($header, widths) {
                    $header.find("tr").each(function(trIndex) {
                        $(this).find("th, td").each(function(cellIndex) {
                            var width = widths[trIndex][cellIndex];
                            $(this).css({
                                boxSizing: "border-box",
                                width: width
                            });
                        });
                    });
                }
            } ]);
            function StickyTableHeader($container, options) {
                _classCallCheck(this, StickyTableHeader);
                this.$container = $container;
                this.options = $.extend(true, {}, $.fn.stickyTableHeader.defaults, options);
                this.id = instanceCount++;
                this.$table = this.$container.find("> table");
                if (!this.$table.length) {
                    StickyTableHeader.logError("No table element found within container element");
                    return;
                }
                this.$win = $(window);
                this.tableSizes = StickyTableHeader.getTableSizes(this.$table);
                if (this.options.outsideViewportOnly && this.tableSizes.height < this.$win.height()) {
                    return;
                }
                var $thead = this.$table.children("thead");
                this.$header = StickyTableHeader.constructHeader($thead, this.$table.attr("class"), this.tableSizes, this.options);
                var cellWidths = StickyTableHeader.getOriginalCellWidths($thead);
                StickyTableHeader.setCloneCellWidths(this.$header, cellWidths);
                this.$header.prependTo(this.$container);
                this.$container.css("position", "relative");
                this.$table.addClass(this.options.css.active);
                this.attachScrollEvent();
            }
            _createClass(StickyTableHeader, [ {
                key: "attachScrollEvent",
                value: function attachScrollEvent() {
                    var $win = this.$win, $header = this.$header, _this$options = this.options, scrollingClass = _this$options.css.scrolling, scrollThrottle = _this$options.scrollThrottle, _this$options$offset = _this$options.offset, top = _this$options$offset.top, topScrolling = _this$options$offset.topScrolling;
                    var headerHeight = $header.outerHeight();
                    var _this$tableSizes = this.tableSizes, tableTopPos = _this$tableSizes.topPos, tableBottomPos = _this$tableSizes.bottomPos, width = _this$tableSizes.width;
                    var isScrollingTable = true;
                    var handler = function handler() {
                        var scrollPos = $win.scrollTop();
                        var scrollInsideTable = scrollPos > tableTopPos && scrollPos < tableBottomPos - headerHeight;
                        var scrollAboveTable = scrollPos < tableTopPos;
                        var scrollBelowTable = scrollPos > tableBottomPos - headerHeight;
                        if (scrollInsideTable && isScrollingTable) {
                            $header.css({
                                position: "fixed",
                                top: topScrolling,
                                width: width
                            });
                            $header.addClass(scrollingClass);
                            isScrollingTable = false;
                        }
                        if (scrollAboveTable && !isScrollingTable) {
                            $header.css({
                                position: "absolute",
                                top: top,
                                bottom: 0,
                                width: width
                            });
                            $header.removeClass(scrollingClass);
                            isScrollingTable = true;
                        }
                        if (scrollBelowTable && !isScrollingTable) {
                            $header.css({
                                position: "absolute",
                                top: "auto",
                                bottom: 0,
                                width: width
                            });
                            $header.removeClass(scrollingClass);
                            isScrollingTable = true;
                        }
                    };
                    $win.on("scroll.".concat(PLUGIN_NAME, "-").concat(this.id), throttle(handler, scrollThrottle, {
                        leading: true
                    }));
                }
            }, {
                key: "detachScrollEvent",
                value: function detachScrollEvent() {
                    this.$win.off("scroll.".concat(PLUGIN_NAME, "-").concat(this.id));
                }
            }, {
                key: "destroy",
                value: function destroy() {
                    this.$container.css("position", "");
                    this.$table.removeClass(this.options.css.active);
                    this.$header.remove();
                    this.detachScrollEvent();
                    this.$container.removeData(PLUGIN_NAME);
                }
            } ]);
            return StickyTableHeader;
        }();
        $.fn.stickyTableHeader = function(options) {
            return this.each(function() {
                var $this = $(this);
                if (!$this.data(PLUGIN_NAME)) {
                    $this.data(PLUGIN_NAME, new StickyTableHeader($this, options));
                }
            });
        };
        $.fn.stickyTableHeader.StickyTableHeader = StickyTableHeader;
        $.fn.stickyTableHeader.defaults = {
            outsideViewportOnly: true,
            scrollThrottle: 50,
            offset: {
                top: 0,
                topScrolling: 0
            },
            css: {
                header: "StickyTableHeader",
                scrolling: "is-scrolling",
                active: "is-stickyTableHeaderActive"
            },
            zIndex: 2
        };
    }, function(module, exports) {
        module.exports = __WEBPACK_EXTERNAL_MODULE__1__;
    }, function(module, exports, __webpack_require__) {
        (function(global) {
            var FUNC_ERROR_TEXT = "Expected a function";
            var NAN = 0 / 0;
            var symbolTag = "[object Symbol]";
            var reTrim = /^\s+|\s+$/g;
            var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
            var reIsBinary = /^0b[01]+$/i;
            var reIsOctal = /^0o[0-7]+$/i;
            var freeParseInt = parseInt;
            var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
            var freeSelf = typeof self == "object" && self && self.Object === Object && self;
            var root = freeGlobal || freeSelf || Function("return this")();
            var objectProto = Object.prototype;
            var objectToString = objectProto.toString;
            var nativeMax = Math.max, nativeMin = Math.min;
            var now = function() {
                return root.Date.now();
            };
            function debounce(func, wait, options) {
                var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
                if (typeof func != "function") {
                    throw new TypeError(FUNC_ERROR_TEXT);
                }
                wait = toNumber(wait) || 0;
                if (isObject(options)) {
                    leading = !!options.leading;
                    maxing = "maxWait" in options;
                    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
                    trailing = "trailing" in options ? !!options.trailing : trailing;
                }
                function invokeFunc(time) {
                    var args = lastArgs, thisArg = lastThis;
                    lastArgs = lastThis = undefined;
                    lastInvokeTime = time;
                    result = func.apply(thisArg, args);
                    return result;
                }
                function leadingEdge(time) {
                    lastInvokeTime = time;
                    timerId = setTimeout(timerExpired, wait);
                    return leading ? invokeFunc(time) : result;
                }
                function remainingWait(time) {
                    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, result = wait - timeSinceLastCall;
                    return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
                }
                function shouldInvoke(time) {
                    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
                    return lastCallTime === undefined || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
                }
                function timerExpired() {
                    var time = now();
                    if (shouldInvoke(time)) {
                        return trailingEdge(time);
                    }
                    timerId = setTimeout(timerExpired, remainingWait(time));
                }
                function trailingEdge(time) {
                    timerId = undefined;
                    if (trailing && lastArgs) {
                        return invokeFunc(time);
                    }
                    lastArgs = lastThis = undefined;
                    return result;
                }
                function cancel() {
                    if (timerId !== undefined) {
                        clearTimeout(timerId);
                    }
                    lastInvokeTime = 0;
                    lastArgs = lastCallTime = lastThis = timerId = undefined;
                }
                function flush() {
                    return timerId === undefined ? result : trailingEdge(now());
                }
                function debounced() {
                    var time = now(), isInvoking = shouldInvoke(time);
                    lastArgs = arguments;
                    lastThis = this;
                    lastCallTime = time;
                    if (isInvoking) {
                        if (timerId === undefined) {
                            return leadingEdge(lastCallTime);
                        }
                        if (maxing) {
                            timerId = setTimeout(timerExpired, wait);
                            return invokeFunc(lastCallTime);
                        }
                    }
                    if (timerId === undefined) {
                        timerId = setTimeout(timerExpired, wait);
                    }
                    return result;
                }
                debounced.cancel = cancel;
                debounced.flush = flush;
                return debounced;
            }
            function throttle(func, wait, options) {
                var leading = true, trailing = true;
                if (typeof func != "function") {
                    throw new TypeError(FUNC_ERROR_TEXT);
                }
                if (isObject(options)) {
                    leading = "leading" in options ? !!options.leading : leading;
                    trailing = "trailing" in options ? !!options.trailing : trailing;
                }
                return debounce(func, wait, {
                    leading: leading,
                    maxWait: wait,
                    trailing: trailing
                });
            }
            function isObject(value) {
                var type = typeof value;
                return !!value && (type == "object" || type == "function");
            }
            function isObjectLike(value) {
                return !!value && typeof value == "object";
            }
            function isSymbol(value) {
                return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
            }
            function toNumber(value) {
                if (typeof value == "number") {
                    return value;
                }
                if (isSymbol(value)) {
                    return NAN;
                }
                if (isObject(value)) {
                    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
                    value = isObject(other) ? other + "" : other;
                }
                if (typeof value != "string") {
                    return value === 0 ? value : +value;
                }
                value = value.replace(reTrim, "");
                var isBinary = reIsBinary.test(value);
                return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
            }
            module.exports = throttle;
        }).call(this, __webpack_require__(3));
    }, function(module, exports) {
        var g;
        g = function() {
            return this;
        }();
        try {
            g = g || new Function("return this")();
        } catch (e) {
            if (typeof window === "object") g = window;
        }
        module.exports = g;
    } ]);
});